// **********************************************************************
//
// Copyright (c) 2003-2008 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.0
// Generated from file `OmniaUITestInterface.ice'

#include <OmniaUITestInterface.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __OmniaUITest__OmniaUITestInterface__GetShiftRegister_name = "GetShiftRegister";

::Ice::Object* IceInternal::upCast(::OmniaUITest::OmniaUITestInterface* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::OmniaUITest::OmniaUITestInterface* p) { return p; }

void
OmniaUITest::__read(::IceInternal::BasicStream* __is, ::OmniaUITest::OmniaUITestInterfacePrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::OmniaUITest::OmniaUITestInterface;
        v->__copyFrom(proxy);
    }
}

bool
OmniaUITest::EggInformation::operator==(const EggInformation& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(Normal != __rhs.Normal)
    {
        return false;
    }
    if(OffGrade != __rhs.OffGrade)
    {
        return false;
    }
    if(Extra != __rhs.Extra)
    {
        return false;
    }
    if(Blood != __rhs.Blood)
    {
        return false;
    }
    if(Dirt != __rhs.Dirt)
    {
        return false;
    }
    if(ColumnCode != __rhs.ColumnCode)
    {
        return false;
    }
    if(RowCode != __rhs.RowCode)
    {
        return false;
    }
    return true;
}

bool
OmniaUITest::EggInformation::operator<(const EggInformation& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(Normal < __rhs.Normal)
    {
        return true;
    }
    else if(__rhs.Normal < Normal)
    {
        return false;
    }
    if(OffGrade < __rhs.OffGrade)
    {
        return true;
    }
    else if(__rhs.OffGrade < OffGrade)
    {
        return false;
    }
    if(Extra < __rhs.Extra)
    {
        return true;
    }
    else if(__rhs.Extra < Extra)
    {
        return false;
    }
    if(Blood < __rhs.Blood)
    {
        return true;
    }
    else if(__rhs.Blood < Blood)
    {
        return false;
    }
    if(Dirt < __rhs.Dirt)
    {
        return true;
    }
    else if(__rhs.Dirt < Dirt)
    {
        return false;
    }
    if(ColumnCode < __rhs.ColumnCode)
    {
        return true;
    }
    else if(__rhs.ColumnCode < ColumnCode)
    {
        return false;
    }
    if(RowCode < __rhs.RowCode)
    {
        return true;
    }
    else if(__rhs.RowCode < RowCode)
    {
        return false;
    }
    return false;
}

void
OmniaUITest::EggInformation::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(Normal);
    __os->write(OffGrade);
    __os->write(Extra);
    __os->write(Blood);
    __os->write(Dirt);
    __os->write(ColumnCode);
    __os->write(RowCode);
}

void
OmniaUITest::EggInformation::__read(::IceInternal::BasicStream* __is)
{
    __is->read(Normal);
    __is->read(OffGrade);
    __is->read(Extra);
    __is->read(Blood);
    __is->read(Dirt);
    __is->read(ColumnCode);
    __is->read(RowCode);
}

void
OmniaUITest::__writeShiftRegisterRow(::IceInternal::BasicStream* __os, const ::OmniaUITest::EggInformation* begin, const ::OmniaUITest::EggInformation* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
OmniaUITest::__readShiftRegisterRow(::IceInternal::BasicStream* __is, ::OmniaUITest::ShiftRegisterRow& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->checkFixedSeq(sz, 10);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
    }
}

void
OmniaUITest::__writeShiftRegister(::IceInternal::BasicStream* __os, const ::OmniaUITest::ShiftRegisterRow* begin, const ::OmniaUITest::ShiftRegisterRow* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        if(begin[i].size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::OmniaUITest::__writeShiftRegisterRow(__os, &begin[i][0], &begin[i][0] + begin[i].size());
        }
    }
}

void
OmniaUITest::__readShiftRegister(::IceInternal::BasicStream* __is, ::OmniaUITest::ShiftRegister& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 1);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        ::OmniaUITest::__readShiftRegisterRow(__is, v[i]);
        __is->endElement();
    }
    __is->endSeq(sz);
}

::OmniaUITest::ShiftRegister
IceProxy::OmniaUITest::OmniaUITestInterface::GetShiftRegister(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__OmniaUITest__OmniaUITestInterface__GetShiftRegister_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::OmniaUITest::OmniaUITestInterface* __del = dynamic_cast< ::IceDelegate::OmniaUITest::OmniaUITestInterface*>(__delBase.get());
            return __del->GetShiftRegister(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::OmniaUITest::OmniaUITestInterface::ice_staticId()
{
    return ::OmniaUITest::OmniaUITestInterface::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::OmniaUITest::OmniaUITestInterface::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::OmniaUITest::OmniaUITestInterface);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::OmniaUITest::OmniaUITestInterface::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::OmniaUITest::OmniaUITestInterface);
}

::IceProxy::Ice::Object*
IceProxy::OmniaUITest::OmniaUITestInterface::__newInstance() const
{
    return new OmniaUITestInterface;
}

::OmniaUITest::ShiftRegister
IceDelegateM::OmniaUITest::OmniaUITestInterface::GetShiftRegister(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __OmniaUITest__OmniaUITestInterface__GetShiftRegister_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::OmniaUITest::ShiftRegister __ret;
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::OmniaUITest::__readShiftRegister(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::OmniaUITest::ShiftRegister
IceDelegateD::OmniaUITest::OmniaUITestInterface::GetShiftRegister(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::OmniaUITest::ShiftRegister& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::OmniaUITest::OmniaUITestInterface* servant = dynamic_cast< ::OmniaUITest::OmniaUITestInterface*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->GetShiftRegister(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::OmniaUITest::ShiftRegister& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __OmniaUITest__OmniaUITestInterface__GetShiftRegister_name, ::Ice::Idempotent, __context);
    ::OmniaUITest::ShiftRegister __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Ice::ObjectPtr
OmniaUITest::OmniaUITestInterface::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __OmniaUITest__OmniaUITestInterface_ids[2] =
{
    "::Ice::Object",
    "::OmniaUITest::OmniaUITestInterface"
};

bool
OmniaUITest::OmniaUITestInterface::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__OmniaUITest__OmniaUITestInterface_ids, __OmniaUITest__OmniaUITestInterface_ids + 2, _s);
}

::std::vector< ::std::string>
OmniaUITest::OmniaUITestInterface::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__OmniaUITest__OmniaUITestInterface_ids[0], &__OmniaUITest__OmniaUITestInterface_ids[2]);
}

const ::std::string&
OmniaUITest::OmniaUITestInterface::ice_id(const ::Ice::Current&) const
{
    return __OmniaUITest__OmniaUITestInterface_ids[1];
}

const ::std::string&
OmniaUITest::OmniaUITestInterface::ice_staticId()
{
    return __OmniaUITest__OmniaUITestInterface_ids[1];
}

::Ice::DispatchStatus
OmniaUITest::OmniaUITestInterface::___GetShiftRegister(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::OmniaUITest::ShiftRegister __ret = GetShiftRegister(__current);
    if(__ret.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        ::OmniaUITest::__writeShiftRegister(__os, &__ret[0], &__ret[0] + __ret.size());
    }
    return ::Ice::DispatchOK;
}

static ::std::string __OmniaUITest__OmniaUITestInterface_all[] =
{
    "GetShiftRegister",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::Ice::DispatchStatus
OmniaUITest::OmniaUITestInterface::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__OmniaUITest__OmniaUITestInterface_all, __OmniaUITest__OmniaUITestInterface_all + 5, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __OmniaUITest__OmniaUITestInterface_all)
    {
        case 0:
        {
            return ___GetShiftRegister(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
OmniaUITest::OmniaUITestInterface::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
OmniaUITest::OmniaUITestInterface::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
OmniaUITest::OmniaUITestInterface::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type OmniaUITest::OmniaUITestInterface was not generated with stream support";
    throw ex;
}

void
OmniaUITest::OmniaUITestInterface::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type OmniaUITest::OmniaUITestInterface was not generated with stream support";
    throw ex;
}

void 
OmniaUITest::__patch__OmniaUITestInterfacePtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::OmniaUITest::OmniaUITestInterfacePtr* p = static_cast< ::OmniaUITest::OmniaUITestInterfacePtr*>(__addr);
    assert(p);
    *p = ::OmniaUITest::OmniaUITestInterfacePtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::OmniaUITest::OmniaUITestInterface::ice_staticId(), v->ice_id());
    }
}

bool
OmniaUITest::operator==(const ::OmniaUITest::OmniaUITestInterface& l, const ::OmniaUITest::OmniaUITestInterface& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
OmniaUITest::operator<(const ::OmniaUITest::OmniaUITestInterface& l, const ::OmniaUITest::OmniaUITestInterface& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
