// **********************************************************************
//
// Copyright (c) 2008 Moba bv, All rights reserved.
//
// This is a test program for the ICE framework.
//
// **********************************************************************

#include <Ice/Ice.h>
#include <OmniaUITestInterfaceI.h>

using namespace std;


int
main(int argc, char* argv[])
{
  int status = 0;

  Ice::CommunicatorPtr ic;

  try 
  {
    ic = Ice::initialize( argc, argv );
    Ice::ObjectAdapterPtr adapter = ic->createObjectAdapter("OmniaUITest");

    OmniaUITest::OmniaUITestInterfacePtr lInterfaceObjPtr = new OmniaUITestInterfaceI;
    adapter->add( lInterfaceObjPtr, ic->stringToIdentity( "OmniaUITestServer" ));

    adapter->activate();
    ic->waitForShutdown();
  } 
  catch (const Ice::Exception& e)
  {
    cerr << e << endl;
    status = 1;
  }
  catch(const char* msg)
  {
    cerr << msg << endl;
    status = 1;
  }

  if( ic )
  {
    try
    {
      ic->destroy();
    }
    catch( const Ice::Exception& e )
    {
      cerr << e << endl;
      status = 1;
    }
  }

  return status;
}


