// **********************************************************************
//
// Copyright (c) 2003-2008 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.0
// Generated from file `OmniaUITestInterface.ice'

#ifndef __OmniaUITestInterface_h__
#define __OmniaUITestInterface_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/StreamF.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceProxy
{

namespace OmniaUITest
{

class OmniaUITestInterface;

}

}

namespace OmniaUITest
{

class OmniaUITestInterface;
bool operator==(const OmniaUITestInterface&, const OmniaUITestInterface&);
bool operator<(const OmniaUITestInterface&, const OmniaUITestInterface&);

}

namespace IceInternal
{

::Ice::Object* upCast(::OmniaUITest::OmniaUITestInterface*);
::IceProxy::Ice::Object* upCast(::IceProxy::OmniaUITest::OmniaUITestInterface*);

}

namespace OmniaUITest
{

typedef ::IceInternal::Handle< ::OmniaUITest::OmniaUITestInterface> OmniaUITestInterfacePtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::OmniaUITest::OmniaUITestInterface> OmniaUITestInterfacePrx;

void __read(::IceInternal::BasicStream*, OmniaUITestInterfacePrx&);
void __patch__OmniaUITestInterfacePtr(void*, ::Ice::ObjectPtr&);

}

namespace OmniaUITest
{

struct EggInformation
{
    ::Ice::Short Normal;
    ::Ice::Short OffGrade;
    ::Ice::Short Extra;
    ::Ice::Byte Blood;
    ::Ice::Byte Dirt;
    ::Ice::Byte ColumnCode;
    ::Ice::Byte RowCode;

    bool operator==(const EggInformation&) const;
    bool operator<(const EggInformation&) const;
    bool operator!=(const EggInformation& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const EggInformation& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const EggInformation& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const EggInformation& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::OmniaUITest::EggInformation> ShiftRegisterRow;
void __writeShiftRegisterRow(::IceInternal::BasicStream*, const ::OmniaUITest::EggInformation*, const ::OmniaUITest::EggInformation*);
void __readShiftRegisterRow(::IceInternal::BasicStream*, ShiftRegisterRow&);

typedef ::std::vector< ::OmniaUITest::ShiftRegisterRow> ShiftRegister;
void __writeShiftRegister(::IceInternal::BasicStream*, const ::OmniaUITest::ShiftRegisterRow*, const ::OmniaUITest::ShiftRegisterRow*);
void __readShiftRegister(::IceInternal::BasicStream*, ShiftRegister&);

}

namespace IceProxy
{

namespace OmniaUITest
{

class OmniaUITestInterface : virtual public ::IceProxy::Ice::Object
{
public:

    ::OmniaUITest::ShiftRegister GetShiftRegister()
    {
        return GetShiftRegister(0);
    }
    ::OmniaUITest::ShiftRegister GetShiftRegister(const ::Ice::Context& __ctx)
    {
        return GetShiftRegister(&__ctx);
    }
    
private:

    ::OmniaUITest::ShiftRegister GetShiftRegister(const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<OmniaUITestInterface> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<OmniaUITestInterface*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<OmniaUITestInterface*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<OmniaUITestInterface> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<OmniaUITestInterface*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<OmniaUITestInterface*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<OmniaUITestInterface> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<OmniaUITestInterface*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<OmniaUITestInterface*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<OmniaUITestInterface> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<OmniaUITestInterface*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<OmniaUITestInterface*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<OmniaUITestInterface> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<OmniaUITestInterface*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<OmniaUITestInterface*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<OmniaUITestInterface> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<OmniaUITestInterface*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<OmniaUITestInterface*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<OmniaUITestInterface> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<OmniaUITestInterface*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<OmniaUITestInterface*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<OmniaUITestInterface> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<OmniaUITestInterface*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<OmniaUITestInterface*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<OmniaUITestInterface> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<OmniaUITestInterface*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<OmniaUITestInterface*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<OmniaUITestInterface> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<OmniaUITestInterface*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<OmniaUITestInterface*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<OmniaUITestInterface> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<OmniaUITestInterface*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<OmniaUITestInterface*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<OmniaUITestInterface> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<OmniaUITestInterface*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<OmniaUITestInterface*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<OmniaUITestInterface> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<OmniaUITestInterface*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<OmniaUITestInterface*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<OmniaUITestInterface> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<OmniaUITestInterface*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<OmniaUITestInterface*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<OmniaUITestInterface> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<OmniaUITestInterface*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<OmniaUITestInterface*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<OmniaUITestInterface> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<OmniaUITestInterface*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<OmniaUITestInterface*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<OmniaUITestInterface> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<OmniaUITestInterface*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<OmniaUITestInterface*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<OmniaUITestInterface> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<OmniaUITestInterface*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<OmniaUITestInterface*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<OmniaUITestInterface> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<OmniaUITestInterface*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<OmniaUITestInterface*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

}

}

namespace IceDelegate
{

namespace OmniaUITest
{

class OmniaUITestInterface : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual ::OmniaUITest::ShiftRegister GetShiftRegister(const ::Ice::Context*) = 0;
};

}

}

namespace IceDelegateM
{

namespace OmniaUITest
{

class OmniaUITestInterface : virtual public ::IceDelegate::OmniaUITest::OmniaUITestInterface,
                             virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual ::OmniaUITest::ShiftRegister GetShiftRegister(const ::Ice::Context*);
};

}

}

namespace IceDelegateD
{

namespace OmniaUITest
{

class OmniaUITestInterface : virtual public ::IceDelegate::OmniaUITest::OmniaUITestInterface,
                             virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual ::OmniaUITest::ShiftRegister GetShiftRegister(const ::Ice::Context*);
};

}

}

namespace OmniaUITest
{

class OmniaUITestInterface : virtual public ::Ice::Object
{
public:

    typedef OmniaUITestInterfacePrx ProxyType;
    typedef OmniaUITestInterfacePtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::OmniaUITest::ShiftRegister GetShiftRegister(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___GetShiftRegister(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

}

#endif
